#set -x
file=/tmp/$$

if [ -L /config/dropbear ] ; then
    rm -r /config/dropbear
fi

get_xilinx() {
  md5=$( head /tmp/mnt/update.image.gz | md5sum | awk {'print $1'} )
  if [ "$md5" = "b11b989fa7bafb1b9e2004280e6d6dd6" ]; then
    xilinx="19"
  elif [ "$md5" = "fdf945bc5aabd56e798388809254bc73" ]; then
    xilinx="17"
  else
    xilinx="NA"
    echo "Unknown series" >> /tmp/upgrade_result
  fi
}

patch_files() {
  if [ "$xilinx" = "17" ]; then
    sleep 10
#    sync; echo 1 > /proc/sys/vm/drop_caches
    chmod +x hpatchz
    ./hpatchz 19_uramdisk.image.gz 19-17_patch_uramdisk.image.gz 17_uramdisk.image.gz > /dev/null 2>&1
  fi
}

check_files() {
#  sleep 10
#  sync
#  echo 1 > /proc/sys/vm/drop_caches
  if [ "$xilinx" = "19" ]; then
    md5="$(md5sum 19_uramdisk.image.gz | awk {'print $1'})"
    md5_r="$(cat 19_uramdisk.image.gz.md5sum)"
  elif [ "$xilinx" = "17" ]; then
    md5="$(md5sum 17_uramdisk.image.gz | awk {'print $1'})"
    md5_r="$(cat 17_uramdisk.image.gz.md5sum)"
  fi
  if [ "$md5" != "$md5_r" ]; then
    echo "RUNME: FileList SD Check Failed!!!" >> /tmp/upgrade_result
    exit 3
  fi
}

update_sd() {
  sync; echo 1 > /proc/sys/vm/drop_caches
  if [ "$xilinx" = "19" ]; then
    mv -f 19_uramdisk.image.gz /tmp/mnt/uramdisk.image.gz
    mv -f 19_update.image.gz  /tmp/mnt/update.image.gz
  elif [ "$xilinx" = "17" ]; then
    mv -f 17_uramdisk.image.gz /tmp/mnt/uramdisk.image.gz
    mv -f 17_update.image.gz  /tmp/mnt/update.image.gz
  fi
  sleep 5
}

delete_files() {
  rm -rf /config/scanfreqdone 2>/dev/null
  if [ -e "/nvdata/latest.tar.gz" ]; then
    rm "/nvdata/latest.tar.gz" 2>/dev/null
  fi
  if [ -e "/config/profile.txt" ]; then
    rm "/config/profile.txt" 2>/dev/null
  fi
  if [ -e "/config/manual_freqs.txt" ]; then
    rm "/config/manual_freqs.txt" 2>/dev/null
  fi
  rm -rf /config/profiles 2>/dev/null
  sync
}


get_xilinx
patch_files
check_files
update_sd
delete_files

rm -rf /config/scanfreqdone 2>/dev/null
if [ -e "/nvdata/latest.tar.gz" ]; then
  rm "/nvdata/latest.tar.gz" 2>/dev/null
fi
sync >/dev/null 2>&1
